<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" creationComplete="creationCompleteHandler(event)" title="Pesquisa de Departamento Produto" xmlns:visual="br.com.desenv.framework.component.visual.*"
			   width="925" height="381" xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="DepartamentoProdutoSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			
			import spark.events.IndexChangeEvent;
			
			import br.com.desenv.nepalign.vo.Departamento;
			import br.com.desenv.nepalign.vo.DepartamentoProduto;
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.Produto;
			
			[Bindable]
			public var listaDepartamentoProduto: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			
			[Bindable]
			private var listaProdutoPesquisa: ArrayCollection = new ArrayCollection();
			[Bindable]
			private var listaDepartamentoPesquisa: ArrayCollection = new ArrayCollection();
			
			[Bindable]
			public var useLikeChild:Boolean = false;

			public var produto: Produto;
			
			private var departamentoProdutoComponenteDetalhe: DepartamentoProdutoComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): DepartamentoProduto
			{
				var departamentoProdutoFiltro: DepartamentoProduto = new DepartamentoProduto();
				
				departamentoProdutoFiltro.departamento = ignComboBoxAutoCompleteDepartamentoPesquisa.selectedItem == null?null:ignComboBoxAutoCompleteDepartamentoPesquisa.selectedItem; 
				departamentoProdutoFiltro.produto = this.ignAutoCompleteProduto.itemSelecionado as Produto;				
				return departamentoProdutoFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				if(this.produto != null)
				{
					this.ignAutoCompleteProduto.itemSelecionado = this.produto;
					this.ignAutoCompleteProduto.enabled = false;
					this.buttonPesquisarProdutoPesquisa.visible = false;
				}
				
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				
				var remoteObjectDepartamento: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoService", listarDepartamentoPesquisaResultHandler);	
				remoteObjectDepartamento.getOperation("listar").send();
				
				closeButton.visible = !useLikeChild;
			}
			
			public function carregarValores():void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro()); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaDepartamentoProduto: Page = event.result as Page;
				pageNumber = paginaDepartamentoProduto.pageNumber;
				totalRecords = paginaDepartamentoProduto.totalRecords;
				lastPage = paginaDepartamentoProduto.lastPage();
				listaDepartamentoProduto = paginaDepartamentoProduto.recordList;
				labelPaginaAtual.text = "" + paginaDepartamentoProduto.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaDepartamentoProduto.totalRecords;
			}

// CARREGANDO COMBOS			
			private function listarDepartamentoPesquisaResultHandler( event: ResultEvent ): void 
			{
				listaDepartamentoPesquisa = event.result as ArrayCollection;
				listaDepartamentoPesquisa.addItemAt(null, 0);
			}

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonPesquisarProdutoPesquisa_clickHandler(event:MouseEvent):void
			{
				var produtoComponentePesquisa: ProdutoComponentePesquisa = new ProdutoComponentePesquisa();
				produtoComponentePesquisa.addEventListener("ProdutoSelecionadoEvent", atualizarProdutoPesquisaPorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(produtoComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(produtoComponentePesquisa);
			}
			
			private function atualizarProdutoPesquisaPorSelecaoResultHandler(e:ResultEvent):void
			{
				var novoProduto: Produto = e.result as Produto;
				ignAutoCompleteProduto.itemSelecionado = novoProduto;
				this.produto = novoProduto;
			}
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
					remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var departamentoProdutoComponenteCadastro: DepartamentoProdutoComponenteCadastro = new DepartamentoProdutoComponenteCadastro();
				departamentoProdutoComponenteCadastro.departamentoProduto = new DepartamentoProduto(); 
				departamentoProdutoComponenteCadastro.produto = this.produto;
				departamentoProdutoComponenteCadastro.addEventListener("DepartamentoProdutoIncluidoEvent", atualizarListaDepartamentoProdutoPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(departamentoProdutoComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(departamentoProdutoComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var departamentoProdutoSelecionado: DepartamentoProduto = datagridListaDepartamentoProduto.selectedItem as DepartamentoProduto;
				this.dispatchEvent(new ResultEvent("DepartamentoProdutoSelecionadoEvent",false, true, departamentoProdutoSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaDepartamentoProduto_doubleClickHandler(event:MouseEvent):void
			{
				departamentoProdutoComponenteDetalhe = new DepartamentoProdutoComponenteDetalhe();
				departamentoProdutoComponenteDetalhe.departamentoProduto = datagridListaDepartamentoProduto.selectedItem as DepartamentoProduto;
				departamentoProdutoComponenteDetalhe.addEventListener("DepartamentoProdutoExcluidoEvent", atualizarListaDepartamentoProdutoPorExclusaoResultHandler);
				departamentoProdutoComponenteDetalhe.addEventListener("DepartamentoProdutoAtualizadoEvent", atualizarListaDepartamentoProdutoPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(departamentoProdutoComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(departamentoProdutoComponenteDetalhe);
			}
			
			
			private function atualizarListaDepartamentoProdutoPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaDepartamentoProdutoPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaDepartamentoProdutoPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectDepartamentoProduto: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("departamentoProdutoService", listarResultHandler);	
				remoteObjectDepartamentoProduto.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
			
			protected function ignComboBoxAutoCompleteDepartamentoPesquisa_changeHandler(event:IndexChangeEvent):void
			{
				if(ignComboBoxAutoCompleteDepartamentoPesquisa.selectedIndex == 0)
					ignComboBoxAutoCompleteDepartamentoPesquisa.selectedIndex = -1;
			}
			
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
	</fx:Declarations>
	
	<mx:VBox x="20">
		<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto">
			<mx:GridRow>
				<mx:GridItem>
					<s:Spacer width="130"/>
				</mx:GridItem>
				<mx:GridItem styleName="gridLabel">
					<s:Label text="Departamento:"/>
				</mx:GridItem>
				<mx:GridItem styleName="gridValor">
					<s:VGroup>
						<s:Label id="labelValidacaoDepartamentoPesquisa" styleName="labelValidacao" text="{ignComboBoxAutoCompleteDepartamentoPesquisa.errorString}"/>
						<visual:IgnComboBoxAutoComplete id="ignComboBoxAutoCompleteDepartamentoPesquisa" dataProvider="{listaDepartamentoPesquisa}" labelField="descricao" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}" change="ignComboBoxAutoCompleteDepartamentoPesquisa_changeHandler(event)"/>
					</s:VGroup>
				</mx:GridItem>	
				<mx:GridItem>
					<s:Spacer width="10"/>
				</mx:GridItem>
				<mx:GridItem styleName="gridLabel">
					<s:Label text="Produto:"/>
				</mx:GridItem>
				<mx:GridItem styleName="gridValor">
					<s:VGroup>
						<s:Label id="labelValidacaoProdutoPesquisa" styleName="labelValidacao" text="{ignAutoCompleteProduto.errorString}"/>
						<s:HGroup>
							<autoComplete:IgnAutoComplete width="300" idKeyName="id" palavraChave="nomeProduto" obrigatorio="false" id="ignAutoCompleteProduto" enviarArgumentos="true" destino="produtoService" funcaoChamada="listarPorObjetoFiltro" lenStartConsulta="3"  nomeClasseObjetoFiltro="br.com.desenv.nepalign.vo.Produto" tabEnabled="true"/>
							<s:Button id="buttonPesquisarProdutoPesquisa" width="30" label="..." click="buttonPesquisarProdutoPesquisa_clickHandler(event)"/>
						</s:HGroup>
					</s:VGroup>
				</mx:GridItem>
				<mx:GridItem colSpan="1" styleName="gridValor">
					<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
				</mx:GridItem>
			</mx:GridRow>		
		</mx:Grid>
		<mx:Grid>
			<mx:GridRow>
				<mx:GridItem colSpan="4" horizontalAlign="center">
					<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
					<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
					<mx:Label id="labelPaginaAtual" text=""/>
					<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
					<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
				</mx:GridItem>
			</mx:GridRow>
			<mx:GridRow>
				<mx:GridItem colSpan="4" horizontalAlign="center">
					<mx:DataGrid id="datagridListaDepartamentoProduto"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaDepartamentoProduto}" doubleClick="datagridListaDepartamentoProduto_doubleClickHandler(event)" doubleClickEnabled="true">
						<mx:columns>
							<mx:DataGridColumn visible="false" dataField="id"/>
							<mx:DataGridColumn dataField="produto.nomeProduto" headerText="Produto" resizable="true" width="350"/>
							<mx:DataGridColumn dataField="departamento.descricao" headerText="Departamento" resizable="true" width="250"/>
							<mx:DataGridColumn dataField="departamento.departamentoPai.descricao" headerText="Departamento Pai" resizable="true" width="250"/>
						</mx:columns>
					</mx:DataGrid>
				</mx:GridItem>
			</mx:GridRow>	
			<mx:GridRow>
				<mx:GridItem colSpan="2" horizontalAlign="left">
					<mx:Label id="labelTotalRegistro" text=""/>
				</mx:GridItem>
				<mx:GridItem colSpan="2" horizontalAlign="right">
					<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
					<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)" visible="{!useLikeChild}"/>
				</mx:GridItem>	
			</mx:GridRow>
		</mx:Grid>
	</mx:VBox>
</s:TitleWindow>
